#
# identifiers.awk - script to generate header file for renaming global symbols
#                   in order to reduce kernel namespace pollution
#
# Output is header file for forced-inclusion that adds a prefix "adb3_" to
# all global symbols that do not already begin with adb3.
#
# Usage (in Makefile):
#
#    $(NM) <binary> | awk -f identifiers.awk >identifiers.h
#
BEGIN {
	print "/*";
	print "** identifiers.h - rename ADB3 VxWorks API global symbols to avoid kernel namespace pollution";
	print "**";
	print "** Autogenerated by identifiers.awk; do not edit";
	print "*/";
}

(NF == 3) && match($2, "^[A-TV-Z]$") && !match(tolower($3), "^adb3.+$") { print "#define " $3 " adb3_" $3; }
