WIND_HOME := $(subst \,/,$(WIND_HOME))
WIND_BASE := $(subst \,/,$(WIND_BASE))
WIND_USR  := $(subst \,/,$(WIND_USR))

ifndef DEBUG
$(warning DEBUG not defined, defaulting to true)
DEBUG=true
else
ifeq ($(DEBUG),true))
DEBUG=true
else
ifeq ($(DEBUG),false))
DEBUG=false
else
$(warning DEBUG invalid, defaulting to true)
DEBUG=true
endif
endif
endif

ifdef VSB
VSB_DIR := $(WIND_BASE)/target/lib_$(VSB)
VSB_SUFFIX := _$(VSB)
else
VSB_SUFFIX :=
endif

DEFS_VSBVARS_MK=$(wildcard $(WIND_BASE)/target/h/make/defs.vsbvars.mk)
ifneq ($(DEFS_VSBVARS_MK),)
include $(DEFS_VSBVARS_MK)
endif

INCLUDES += -I$(WIND_BASE)/target/h -I$(WIND_BASE)/target/h/wrn/coreip

ifeq ($(DEBUG),true)
OBJDIR = obj/$(CONFIG)/debug$(VSB_SUFFIX)
BINDIR = bin/$(CONFIG)/debug$(VSB_SUFFIX)
else
OBJDIR = obj/$(CONFIG)/release$(VSB_SUFFIX)
BINDIR = bin/$(CONFIG)/release$(VSB_SUFFIX)
endif

# Libraries
LIBS =

ifndef TARGET
$(error TARGET not defined)
endif

ifndef CPU
$(error CPU not defined)
endif

ifndef SOFTFLOAT
SOFTFLOAT=false
endif

# Define toolchain
ifndef TOOLCHAIN
$(warning TOOLCHAIN not defined, defaulting to diab)
TOOLCHAIN = diab
endif

ifeq ($(TOOLCHAIN),diab)

# Define tools
ifeq ($(SOFTFLOAT),true)
TOOL = sfdiab
else
TOOL = diab
endif
TOOL_FAMILY = diab
CC = dcc
LD = dld
NM = ddump -Np

# DIAB-specific compiler options
CCOPTS   = $(TARGET) -Xforce-prototypes -Xmismatch-warning
ifeq ($(DEBUG),true)
CCOPTS += -g -Xoptimized-debug-off -Xclib-optim-off
else
CCOPTS += -XO
endif
CCOPTS += -i=identifiers.h
CCOPTS_MKDEP = -Xincfile-missing-ignore -Xmake-dependency=0x1

# DIAB-specific linker options
LDOPTS = $(TARGET) -r

else
ifeq ($(TOOLCHAIN),gnu)

# Define tools
ifeq ($(SOFTFLOAT),true)
TOOL = sfgnu
else
TOOL = gnu
endif
TOOL_FAMILY = gnu
ifndef CC
$(error CC not defined, required for GNU toolchain)
endif
ifndef LD
$(error LD not defined, required for GNU toolchain)
endif
ifndef NM
$(error NM not defined, required for GNU toolchain)
endif

# GNU-specific compiler options
CCOPTS = $(TARGET) -ansi -Wall 
ifeq ($(DEBUG),true)
CCOPTS += -g
else
CCOPTS += -O3
endif
CCOPTS += -include identifiers.h
CCOPTS_MKDEP = -M

# GNU-specific linker options
LDOPTS = -r -X

else

$(error Toolchain $(TOOLCHAIN) not supported)

endif
endif

# Add in non-tool-specific compiler options
ifdef EXTRA_CCOPTS
CCOPTS += $(EXTRA_CCOPTS)
endif
CCOPTS += $(INCLUDES) $(DEFINES) -DCPU=$(CPU) -DTOOL=$(TOOL) -DTOOL_FAMILY=$(TOOL_FAMILY) $(ALLFLAGS_VSBDEFS)

# Add in non-tool-specific linker options
ifdef EXTRA_LDOPTS
LDOPTS += $(EXTRA_LDOPTS)
endif
