/*
** File: vxw_param.c  
** Project: VxWorks ADB3 monolithic driver
** Purpose: Driver parameters
**
** (C) Copyright Alpha Data 2010
*/

#include "df.h"
#include "dfvxworks.h"

/*
** Driver parameters are simply symbols that are exported to the namespace of
** the VxWorks kernel.
*/

unsigned int adb3DrvAssumeXrmPresent = 0;
unsigned int adb3DrvDmaMapLength = 64;
unsigned int adb3DrvEnableVpdWrite = 0;
unsigned int adb3DrvIncludeDiagSensors = 0;
unsigned int adb3DrvLegacyHardware = 0;
unsigned int adb3DrvPciAddress64Bit = 0;
unsigned int adb3DrvSi5338ExposeAllClocks = 0;

DfVxwDriverParameterUint32 g_dfVxwDriverParamUint32[] = {
  { "DmaMapLength", &adb3DrvDmaMapLength },
  { NULL, NULL } /* Terminator */
};

DfVxwDriverParameterBoolean g_dfVxwDriverParamBoolean[] = {
  { "AssumeXrmPresent", &adb3DrvAssumeXrmPresent },
  { "EnableVpdWrite", &adb3DrvEnableVpdWrite },
  { "IncludeDiagSensors", &adb3DrvIncludeDiagSensors },
  { "LegacyHardware", &adb3DrvLegacyHardware },
  { "PciAddress64Bit", &adb3DrvPciAddress64Bit },
  { "Si5338ExposeAllClocks", &adb3DrvSi5338ExposeAllClocks },
  { NULL, NULL } /* Terminator */
};

DfVxwDriverParameterString g_dfVxwDriverParamString[] = {
  { NULL, NULL, 0 } /* Terminator */
};
